<?php

namespace Drupal\Tests\paragraph_lineage\Functional\Controller;

use Drupal\Core\Url;
use Drupal\views\Annotation\ViewsField;
use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;

/**
 * A custom views field that provides a link to paragraph lineage.
 *
 * @group paragraph_lineage
 */
class ParagraphLineageViewControllerTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  public function render(ResultRow $values) {
    $entity_id = $this->getValue($values);

    if (empty($entity_id)) {
      return '';
    }

    try {
      $url = Url::fromRoute('entity.paragraph.canonical', ['paragraph' => $entity_id]);
      return [
        '#type' => 'link',
        '#title' => $this->t('View lineage'),
        '#url' => $url,
        '#attributes' => [
          'class' => ['paragraph-lineage-link'],
        ],
      ];
    }
    catch (\Exception $e) {
      return '';
    }
  }

  /**
   * {@inheritdoc}
   */
  public function query() {
    // This field doesn't need to add anything to the query.
  }

}
